/*
 * Copyright (c) 1992 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * @(#) $Header: filter.h,v 1.3 92/06/08 02:55:44 van Exp $ (LBL)
 */

#ifndef viewnet_filter_h
#define viewnet_filter_h

#include <sys/types.h>
#include <sys/time.h>

class PacketFilter {
public:
	PacketFilter(const char* device, const char* cmdbuf);
	int ReadLen();
	u_int ReadDrops();
	int IOMask() const { return (1 << fd); }
	int Chan() const { return (fd); }
private:
	int bufsize;
	char* buffer;
	int fd;
};

#endif
