/*
 * Copyright (c) 1991 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef numbox_h
#define numbox_h

#include <InterViews/interactor.h>

class Font;
class StringId;

class NumBox : public Interactor {
public:
	NumBox(int w = 0);
	void Init(Font *, int);
	~NumBox();
	void DoSelect(int);
	void SetJustify(Alignment just) { justify = just; }
protected:
	virtual void Reconfig();
	virtual void Redraw(Coord, Coord, Coord, Coord);
	virtual void Handle(Event &);
	double value;
private:
	void DoKey(int);
	Font *font;
	char selected;
	char editing;
	char highlighted;
	Alignment justify;
	short keyindex;
	short width;
	char keybuf[80];
};

#endif
