/*
 * Copyright (c) 1991 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * @(#) $Header: screen.h,v 1.4 92/06/08 02:55:50 van Exp $ (LBL)
 */

#ifndef viewnet_screen_h
#define viewnet_screen_h

#include <InterViews/box.h>

class PacketFilter;
class StripChart;

class Screen : public MonoScene {
    public:
	Screen(PacketFilter* filter, StripChart* chart,
	       const double period, const double fgain, const double pscale);
	void Handle(Event&);
    protected:
	void Advance();

	PacketFilter* const filter;
	StripChart* const chart;
	const double period;
	const double gain;
	const double scale;

	int sum;
	double nexttime;
	double lasttime;
	double timebase;
	double curval;
};

#endif
